//inspired by "Shallow-Deep" by Kandinsky

PShape tower;
float upBal = 0;
float noiseVal;
float noiseScale=0.047;
color colour;
color yellow = color(249, 229, 77, 180);
float blCol= 0;
float mainPerimeter = width / 22 * 3;
Balloon1 b; 
Balloon2 b2;
Balloon3 b3;
Balloon4 b4;
Balloon5 b5;
Balloon6 b6;
mainBalloon bMain;
Ship ship;



color red= color(252, 141, 129, 220);
//color red = color(186, 47, 42, 200);

void setup(){
  size(1230, 840);  //cca 22/15
  background(9);
  b = new Balloon1();
  b2 = new Balloon2();
  b3 = new Balloon3();
  b4 = new Balloon4();
  b5 = new Balloon5();
  b6 = new Balloon6();
  bMain = new mainBalloon();
  ship = new Ship();
  
  tower = createShape();
  tower.beginShape();
  tower.fill(200);
  tower.stroke(0);
  tower.vertex(width/2 +10, (height/15)*14);
  tower.vertex((width/2) +20, (height/15)*13);
  tower.vertex((width/2) +40, (height/15)*13);
  tower.vertex((width/2) +35, (height/6)*5);
  tower.vertex((width/2) +60, (height/6)*5);
  tower.vertex((width/2) +60, (height/5)*4);
  tower.vertex((width/2) +75, (height/5)*4);
  tower.vertex((width/2) +71, (height/15)*11);  //hore vlavo
  tower.vertex((width/2) +95, (height/15)*11);
  tower.vertex((width/2) +95, (height/15)*14);
  tower.endShape(CLOSE);
  
}

float up1 = 0;
float up2 = 0;
float up3 = 0;
float up4 = 0;
float up5 = 0;

void draw() {
  
  loadPixels();
  for (int x = 0; x < (width*height); x++){
    noiseDetail(4,0.5);
    noiseVal = noise((x % width)* noiseScale, ((x/width)) * noiseScale);
    colour = color(noiseVal * 45, noiseVal * 47, noiseVal * (52+blCol));
    pixels[x] = colour;    
  }
  updatePixels();
  
  bMain.display(up1, up2);
  
  fill(255, 100);
  arc((width/2) +95, (height/15)*14, 110, 100, radians(200), radians(340), CHORD);
  
  shape(tower);
  
  int rectSide=width/150;
  for(int i =0; i<8; i++){
    fill(239, 148, 204, 240);
    rect((width/11)*4 +(rectSide*i*2.2), (height/15)*13, rectSide, rectSide*2.3 );
  }
  
  int sqSide=width/50;
  for(int i =0; i<4; i++){
    fill(170, 29, 43, 140);
    rect((width/24)*5 +(sqSide*i*2), height/7, sqSide, sqSide );
  }
  
  float lineY = (height/15)*12.5;
  for(int i =0; i<3; i++){
    strokeWeight(2);
    stroke(237, 199, 64);
    line((width/22)*15.2, lineY +(i*11), (width/22)*16.8, lineY +(i*11));
  }
  
  b.display(up1);
  
  if((height/3) -upBal >= (height/7)+(width/22)-2){
    upBal+=1;    
  }
  b2.display(upBal);
  
  b3.display(up3,up1, 0);
  b4.display(up2);
  b5.display(up4, up5);
  b6.display(up3);
  ship.display(up1);

  
  blCol+=0.05;
  
  up1 += 0.8;
  up2 +=2;
  up3 += 1.4;
  up4 += random(1, 2);
  up5 += 0.2;

  //saveFrame("frames/######.png");
}

class mainBalloon{
  //float radius = 150 + up1;
  
  void display(float up1, float up2){
    strokeWeight(1);
    stroke(241, 196, 242, 230);
    line(((width/ 5) * 2 + up1)+(150+ up1)/2,  (height/5)*2 - up2 +10,    ((width/ 5) * 2 + up1),   ((height/5)*2 - up2) + (150+ up1)+100);
    line(((width/ 5) * 2 + up1)-(150+ up1)/2,  (height/5)*2 - up2 +10,    ((width/ 5) * 2 + up1) -7,   ((height/5)*2 - up2) + (150+ up1)+100);
    
    strokeWeight(2);
    stroke(0, 90);
    fill(255, 169);
    arc((width/ 5) * 2 + up1, (height/5)*2 - up2, 150+ up1, 150+ up1, PI+QUARTER_PI, PI + HALF_PI, PIE);
    fill(241, 196, 242, 170);
    arc((width/ 5) * 2 + up1, (height/5)*2 - up2, 150+ up1, 150+ up1, HALF_PI, PI+QUARTER_PI, PIE);
    fill(210, 236, 247, 170);
    arc((width/ 5) * 2 + up1, (height/5)*2 - up2, 150+ up1, 150+ up1, 0, HALF_PI, PIE);
    fill(24, 84, 52, 140);
    arc((width/ 5) * 2 + up1, (height/5)*2 - up2, 150+ up1, 150+ up1, PI + HALF_PI, PI *2, PIE);
    
    noStroke();
    fill(219, 206, 61, 220);
    triangle((((width/ 5) * 2 + up1) -4), ((height/5)*2 - up2) + (150+ up1)+120, ((width/ 5) * 2 + up1) -30, ((height/5)*2 - up2) + (150+ up1)+97, ((width/ 5) * 2 + up1) +20, ((height/5)*2 - up2) + (150+ up1)+97 );
    fill(212, 189, 252, 180);
    triangle((((width/ 5) * 2 + up1) -4), ((height/5)*2 - up2) + (150+ up1)+140, ((width/ 5) * 2 + up1) -15, ((height/5)*2 - up2) + (150+ up1)+120, ((width/ 5) * 2 + up1) +5, ((height/5)*2 - up2) + (150+ up1)+120);
   
    
  }
}

class Balloon1{
  float radius = width/11;
  float centerX = (width/ 10);
  float centerY = (height/8);

  void display(float move){
    strokeWeight(1);
    stroke(120, 238, 253, 100);
    line(centerX+radius/2 - 3, centerY +17 -move, centerX -3, centerY + radius*1.41 - move);
    line(centerX-radius/2 + 3, centerY +17 -move, centerX -3, centerY + radius*1.41 - move);
    
    strokeWeight(2);
    stroke(0, 90);
    fill(120, 238, 253, 100);
    arc(centerX, centerY - move, radius, radius, radians(56), radians(236), PIE);
    fill(238, 204, 76, 129);
    arc(centerX, centerY - move, radius, radius, radians(236), radians(416), PIE);
    
    
    
    noStroke();
    fill(159, 133, 163);
    triangle(centerX - 3, centerY + radius*1.55 - move,  centerX - 16, centerY + radius*1.41 - move,centerX + 12, centerY + radius*1.41 -move);
  }
}

class Balloon2{
  float radius = width/22;
  float centerXL = (width/22) *5;
  float centerY = (height/3);
  float centerXR = centerXL + radius +5;


  void display(float move){
    //left
    strokeWeight(1);
    stroke(79, 21, 39, 120);
    line(centerXL+radius/2 - 1, centerY -move, centerXL, centerY + radius*2.45 - move);
    line(centerXL-radius/2 + 1, centerY -move, centerXL, centerY + radius*2.45 - move);
    noStroke();
    fill(35, 57, 91, 200);
    arc(centerXL, centerY - move, radius, radius, 0, PI, PIE);
    fill(172, 214, 224);
    arc(centerXL, centerY - move, radius, radius, PI, 2*PI, PIE);
    
    noStroke();
    fill(249, 229, 77);
    triangle(centerXL, centerY + radius*2.45 - move,  centerXL - 10, centerY + 2.7*radius - move,centerXL + 10, centerY + 2.7*radius -move);
 
    //right
    strokeWeight(1);
    stroke(61, 128, 153, 150);
    line(centerXR+radius/2 - 1, centerY -move, centerXR, centerY + radius*2 - move);
    stroke(61, 128, 153);
    line(centerXR-radius/2 + 1, centerY -move, centerXR, centerY + radius*2 - move);
    stroke(0);
    strokeWeight(1);
    fill(205, 242, 232);
    ellipse(centerXR, centerY - move, radius, radius);
    fill(249, 229, 77);
    arc(centerXR, centerY - move, radius, radius, radians(30), radians(150), CHORD);
    arc(centerXR, centerY - move, radius, radius, radians(180), radians(360), CHORD);
    fill(218, 232, 230);
    arc(centerXR, centerY - move, radius, radius, radians(210), radians(330), CHORD);
    
    noStroke();
    fill(red);
    rect(centerXR-8, centerY + radius*2 - move, 16, 22);
   
  }
}

class Balloon3{
  float radius = width/18;
  float centerX = (width/ 5) *3;
  float centerY = (height/3) +70;

  void display(float move, float moveX, int degrees){
    strokeWeight(2);
    stroke(61, 119, 130, 120);
    line(centerX+radius/2 - 1 +moveX, centerY -move, centerX +moveX, centerY + radius*1.5 - move);
    line(centerX-radius/2 + 1 +moveX, centerY -move, centerX +moveX, centerY + radius*1.5 - move);
    
    strokeWeight(2);
    stroke(0, 90);
    fill(240, 248, 253);
    arc(centerX+moveX, centerY - move, radius, radius, radians(degrees), radians(degrees+180), PIE);
    fill(238, 204, 76, 200);
    arc(centerX+moveX, centerY - move, radius, radius, radians(degrees+180), radians(degrees+360), PIE);
    
    stroke(22, 220);
    fill(red);
    rect(centerX-12 +moveX, centerY + radius*1.5 - move, 24, 12);
  }
}

class Balloon4{
  float radius = width/14;
  float centerX = ((width/ 3) *2);
  float centerY = (height/5);

  void display(float move){
    strokeWeight(2);
    stroke(252, 189, 233, 40);
    line(centerX+radius/2 - 2, centerY -move +12, centerX, centerY + radius*1.5 - move);
    line(centerX-radius/2 + 2, centerY -move +12, centerX, centerY + radius*1.5 - move);

    stroke(0, 90);
    fill(61, 119, 130, 160);
    arc(centerX , centerY - move, radius, radius, radians(90), radians(270), PIE);
    fill(247, 155, 174, 100);
    arc(centerX, centerY - move, radius, radius, radians(270), radians(450), PIE);
    
    noStroke();
    fill(yellow);
    rect(centerX-8, centerY + radius*1.5 - move, 16, 22);

 }
}

class Balloon5{
  float radius = width/12;
  float centerX = (width/15) *12;
  float centerY = (height/3);


  void display(float move, float moveX){
    strokeWeight(2);
    stroke(49, 32, 119, 120);
    line(centerX+radius/2 - 1 + moveX, centerY -move, centerX -3 + moveX, centerY + radius*1.8 - move);
    stroke(49, 32, 119, 200);
    line(centerX-radius/2 + 1 + moveX, centerY -move, centerX -3 + moveX, centerY + radius*1.8 - move);
    stroke(0);
    strokeWeight(1);
    fill(211, 199, 65);
    ellipse(centerX + moveX, centerY - move, radius, radius);
    fill(47, 132, 125);
    arc(centerX+ moveX, centerY - move, radius, radius, radians(120), radians(240), CHORD);
    arc(centerX+ moveX, centerY - move, radius, radius, radians(270), radians(450), CHORD);
    fill(219, 206, 61);
    arc(centerX+ moveX, centerY - move, radius, radius, radians(300), radians(420), CHORD);
    
    noStroke();
    fill(107, 28, 51, 180);
    triangle(centerX-18+ moveX, centerY + radius*1.8 - move, centerX+12+ moveX, centerY + radius*1.8 - move, centerX -3 + moveX, centerY + radius*2 - move );
    fill(219, 206, 61, 170);
    triangle(centerX-18+ moveX, centerY + radius*2.18 - move, centerX+13+ moveX, centerY + radius*2.2 - move, centerX -3 + moveX, centerY + radius*2 - move );
   
  }
}

class Balloon6{
  float radius = width/9;
  float centerX = (width - 100);
  float centerY = (height/3) +70;

  void display(float move){
    strokeWeight(1);
    stroke(238, 204, 76, 70);
    line(centerX+radius/2 -4, centerY+20 -move, centerX, centerY + radius*1.5 - move);
    stroke(238, 204, 76, 100);
    line(centerX-radius/2 +2, centerY+15 -move, centerX, centerY + radius*1.5 - move);
    
    strokeWeight(2);
    stroke(0, 90);
    fill(238, 204, 76, 160);
    arc(centerX, centerY - move, radius, radius, radians(120), radians(300), PIE);
    fill(7, 33, 51, 180);
    arc(centerX, centerY - move, radius, radius, radians(300), radians(480), PIE);
    
    noStroke();
    fill(160, 77, 249, 100);
    rect(centerX-25, centerY + radius*1.5 - move, 50, 5);
    fill(107, 28, 51, 180);
    rect(centerX-13, centerY + radius*1.6 - move, 25, 5);
  }
}

class Ship{
  float radius = (height/15)*4 ;
  float centerX = (width /22) *3;
  float centerY = (height/15)*11;
  void display(float move){
    fill(252, 224, 113, 150);
    arc(centerX- move, centerY, radius, radius, radians(135), radians(225), CHORD);
    fill(30, 112, 87, 160);
    arc(centerX - 160- move, centerY+20, radius-30, radius-30, radians(-35), radians(35), CHORD);
    fill(247, 155, 174, 100);
    quad((width/22) - move , (height/15)*13, (width/22) - move +40, (height/15)*13, (width/22) - move +60, (height/15)*13 -10, (width/22) - move +20, (height/15)*13 -10);
  }
}